module     p0_dubar_emnebarbbbar_d25h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d25h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram25_sign, shift => diagram25_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t7 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t8 = (Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))
      t9 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t10 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d25 = (abb25n1+t1*abb25n16+t2*abb25n17+t3*abb25n18+t4*abb25n2+t5*abb25n25+&
      &t6*abb25n31+t7*abb25n4+t8*abb25n5+t9*abb25n8+abb25n11*(Q(1)*spvak1k2(1)-Q&
      &(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+abb25n3*(Q(1)*spval6l5&
      &(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(4))+t1*t10*abb25n14+t&
      &1*t11*abb25n26+t1*t4*abb25n9+t1*t6*abb25n22+t10*t2*abb25n15+t10*t7*abb25n&
      &12+t10*t9*abb25n13+t11*t2*abb25n30+t11*t7*abb25n28+t11*t9*abb25n27+t2*t4*&
      &abb25n7+t2*t6*abb25n23+t3*t4*abb25n19+t3*t5*abb25n24+t4*t6*abb25n32+t4*t9&
      &*abb25n6+t5*t6*abb25n10+t5*t7*abb25n29+t5*t8*abb25n33+t6*t7*abb25n20+t6*t&
      &9*abb25n21+t3*t4*t5*abb25n34)
      numerator = cmplx(real(d25, ki), aimag(d25), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd25h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d25
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d25 = 0.0_ki
      t1 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))
      t7 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t8 = (Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(4))
      t9 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t10 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t11 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d25 = (abb25n1+t1*abb25n16+t2*abb25n17+t3*abb25n18+t4*abb25n2+t5*abb25n25+&
      &t6*abb25n31+t7*abb25n4+t8*abb25n5+t9*abb25n8+abb25n11*(Q(1)*spvak1k2(1)-Q&
      &(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))+abb25n3*(Q(1)*spval6l5&
      &(1)-Q(2)*spval6l5(2)-Q(3)*spval6l5(3)-Q(4)*spval6l5(4))+t1*t10*abb25n14+t&
      &1*t11*abb25n26+t1*t4*abb25n9+t1*t6*abb25n22+t10*t2*abb25n15+t10*t7*abb25n&
      &12+t10*t9*abb25n13+t11*t2*abb25n30+t11*t7*abb25n28+t11*t9*abb25n27+t2*t4*&
      &abb25n7+t2*t6*abb25n23+t3*t4*abb25n19+t3*t5*abb25n24+t4*t6*abb25n32+t4*t9&
      &*abb25n6+t5*t6*abb25n10+t5*t7*abb25n29+t5*t8*abb25n33+t6*t7*abb25n20+t6*t&
      &9*abb25n21+t3*t4*t5*abb25n34)

      numerator = cmplx(real(d25, ki), aimag(d25), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d25h0l1
