module     p0_dubar_emnebarbbbar_d27h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity0/d27h0l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram27_sign, shift => diagram27_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd27h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d27
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d27 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t7 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4)&
      &)
      t12 = t1*abb27n21
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d27 = (abb27n1+t1*abb27n12+t12*t2+t12*t3+t2*abb27n15+t3*abb27n15+t4*abb27n&
      &16+t5*abb27n17+t6*abb27n18+t7*abb27n2+t8*abb27n25+t9*abb27n3+abb27n11*(Q(&
      &1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))+t1*t4*&
      &abb27n22+t1*t5*abb27n23+t1*t7*abb27n4+t1*t8*abb27n26+t1*t9*abb27n13+t1*ab&
      &b27n19*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(&
      &4))+t1*abb27n6*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*s&
      &pval6k1(4))+t10*t11*abb27n14+t10*t6*abb27n20+t11*t13*abb27n5+t13*t6*abb27&
      &n7+t2*t6*abb27n8+t3*t6*abb27n8+t4*t6*abb27n9+t5*t6*abb27n10+t6*t8*abb27n2&
      &4)
      numerator = cmplx(real(d27, ki), aimag(d27), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd27h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d27
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d27 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spval6k2(1)-Q(2)*spval6k2(2)-Q(3)*spval6k2(3)-Q(4)*spval6k2(4))
      t7 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t8 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t9 = (Q(1)*spval5k4(1)-Q(2)*spval5k4(2)-Q(3)*spval5k4(3)-Q(4)*spval5k4(4))
      t10 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t11 = (Q(1)*spval5k2(1)-Q(2)*spval5k2(2)-Q(3)*spval5k2(3)-Q(4)*spval5k2(4)&
      &)
      t12 = t1*abb27n21
      t13 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      d27 = (abb27n1+t1*abb27n12+t12*t2+t12*t3+t2*abb27n15+t3*abb27n15+t4*abb27n&
      &16+t5*abb27n17+t6*abb27n18+t7*abb27n2+t8*abb27n25+t9*abb27n3+abb27n11*(Q(&
      &1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4))+t1*t4*&
      &abb27n22+t1*t5*abb27n23+t1*t7*abb27n4+t1*t8*abb27n26+t1*t9*abb27n13+t1*ab&
      &b27n19*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*spval6k4(3)-Q(4)*spval6k4(&
      &4))+t1*abb27n6*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*s&
      &pval6k1(4))+t10*t11*abb27n14+t10*t6*abb27n20+t11*t13*abb27n5+t13*t6*abb27&
      &n7+t2*t6*abb27n8+t3*t6*abb27n8+t4*t6*abb27n9+t5*t6*abb27n10+t6*t8*abb27n2&
      &4)

      numerator = cmplx(real(d27, ki), aimag(d27), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d27h0l1
