module     p0_dubar_emnebarbbbar_d22h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity1/d22h1l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram22_sign, shift => diagram22_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd22h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d22

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d22 = 0.0_ki
      d22 = (abb22n1+abb22n2*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)&
      &-Q(4)*spval6k1(4))+abb22n3*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2&
      &k1(3)-Q(4)*spvak2k1(4))+abb22n4*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*s&
      &pval6k4(3)-Q(4)*spval6k4(4))+abb22n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb22n6*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+abb22n6*(&
      &Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb22n7*(Q(1)*spvak3k4(1)-Q(&
      &2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb22n8*(Q(1)*spvak2k4(&
      &1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb22n9*(Q(1)*spva&
      &k3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)))
      numerator = cmplx(real(d22, ki), aimag(d22), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd22h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d22

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d22 = 0.0_ki
      d22 = (abb22n1+abb22n2*(Q(1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)&
      &-Q(4)*spval6k1(4))+abb22n3*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2&
      &k1(3)-Q(4)*spvak2k1(4))+abb22n4*(Q(1)*spval6k4(1)-Q(2)*spval6k4(2)-Q(3)*s&
      &pval6k4(3)-Q(4)*spval6k4(4))+abb22n5*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(&
      &4)*k1(4))+abb22n6*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))+abb22n6*(&
      &Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+abb22n7*(Q(1)*spvak3k4(1)-Q(&
      &2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+abb22n8*(Q(1)*spvak2k4(&
      &1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+abb22n9*(Q(1)*spva&
      &k3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)))

      numerator = cmplx(real(d22, ki), aimag(d22), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d22h1l1
