module     p0_dubar_emnebarbbbar_d1h2l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity2/d1h2l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram1_sign, shift => diagram1_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd1h2
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3+k2-k4
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t9 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t10 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t11 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4)&
      &)
      t12 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t13 = t2*abb1n6
      d1 = (t1*abb1n10+t10*abb1n8+t11*abb1n9+t13*t7+t13*t8+t2*abb1n12+t3*abb1n17&
      &+t4*abb1n2+t5*abb1n24+t6*abb1n29+t7*abb1n7+t8*abb1n7+t9*abb1n8+abb1n1*(Q(&
      &1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))+t1*t11&
      &*abb1n11+t1*t2*abb1n13+t10*t12*abb1n16+t11*t12*abb1n18+t11*t3*abb1n4+t11*&
      &t7*abb1n3+t11*t8*abb1n3+t12*t2*abb1n19+t12*t3*abb1n15+t12*t4*abb1n25+t12*&
      &t5*abb1n31+t12*t6*abb1n28+t12*t7*abb1n14+t12*t8*abb1n14+t12*t9*abb1n16+t1&
      &2*abb1n27*(Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4&
      &k1(4))+t2*t3*abb1n5+t3*t4*abb1n26+t3*t5*abb1n21+t3*t6*abb1n23+t5*t7*abb1n&
      &20+t5*t8*abb1n20+t6*t7*abb1n22+t6*t8*abb1n22+t11*t12*t5*abb1n30+t12*t2*t5&
      &*abb1n32)
      numerator = cmplx(real(d1, ki), aimag(d1), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd1h2
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3+k2-k4
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*spval5k1(1)-Q(2)*spval5k1(2)-Q(3)*spval5k1(3)-Q(4)*spval5k1(4))
      t7 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t8 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t9 = (Q(1)*l5(1)-Q(2)*l5(2)-Q(3)*l5(3)-Q(4)*l5(4))
      t10 = (Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))
      t11 = (Q(1)*spval5l6(1)-Q(2)*spval5l6(2)-Q(3)*spval5l6(3)-Q(4)*spval5l6(4)&
      &)
      t12 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t13 = t2*abb1n6
      d1 = (t1*abb1n10+t10*abb1n8+t11*abb1n9+t13*t7+t13*t8+t2*abb1n12+t3*abb1n17&
      &+t4*abb1n2+t5*abb1n24+t6*abb1n29+t7*abb1n7+t8*abb1n7+t9*abb1n8+abb1n1*(Q(&
      &1)*spval6k1(1)-Q(2)*spval6k1(2)-Q(3)*spval6k1(3)-Q(4)*spval6k1(4))+t1*t11&
      &*abb1n11+t1*t2*abb1n13+t10*t12*abb1n16+t11*t12*abb1n18+t11*t3*abb1n4+t11*&
      &t7*abb1n3+t11*t8*abb1n3+t12*t2*abb1n19+t12*t3*abb1n15+t12*t4*abb1n25+t12*&
      &t5*abb1n31+t12*t6*abb1n28+t12*t7*abb1n14+t12*t8*abb1n14+t12*t9*abb1n16+t1&
      &2*abb1n27*(Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q(3)*spvak4k1(3)-Q(4)*spvak4&
      &k1(4))+t2*t3*abb1n5+t3*t4*abb1n26+t3*t5*abb1n21+t3*t6*abb1n23+t5*t7*abb1n&
      &20+t5*t8*abb1n20+t6*t7*abb1n22+t6*t8*abb1n22+t11*t12*t5*abb1n30+t12*t2*t5&
      &*abb1n32)

      numerator = cmplx(real(d1, ki), aimag(d1), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d1h2l1
