module     p0_dubar_emnebarbbbar_d29h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity3/d29h3l1.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dubar_emnebarbbbar_groups, only: &
!           & sign => diagram29_sign, shift => diagram29_shift
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd29h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k6+k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t3 = (Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))
      d29 = (abb29n1+t1*abb29n3+t2*abb29n9+abb29n2*(Q(1)*spvak3l6(1)-Q(2)*spvak3&
      &l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+abb29n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q&
      &(3)*k2(3)-Q(4)*k2(4))+abb29n5*(Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spv&
      &ak2l6(3)-Q(4)*spvak2l6(4))+abb29n6*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(&
      &4))+abb29n6*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb29n7*(Q(1)*k&
      &1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*t3*abb29n10+t2*t3*abb29n8)
      numerator = cmplx(real(d29, ki), aimag(d29), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd29h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k6+k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t3 = (Q(1)*spvak2l5(1)-Q(2)*spvak2l5(2)-Q(3)*spvak2l5(3)-Q(4)*spvak2l5(4))
      d29 = (abb29n1+t1*abb29n3+t2*abb29n9+abb29n2*(Q(1)*spvak3l6(1)-Q(2)*spvak3&
      &l6(2)-Q(3)*spvak3l6(3)-Q(4)*spvak3l6(4))+abb29n4*(Q(1)*k2(1)-Q(2)*k2(2)-Q&
      &(3)*k2(3)-Q(4)*k2(4))+abb29n5*(Q(1)*spvak2l6(1)-Q(2)*spvak2l6(2)-Q(3)*spv&
      &ak2l6(3)-Q(4)*spvak2l6(4))+abb29n6*(Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(&
      &4))+abb29n6*(Q(1)*l6(1)-Q(2)*l6(2)-Q(3)*l6(3)-Q(4)*l6(4))+abb29n7*(Q(1)*k&
      &1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))+t1*t3*abb29n10+t2*t3*abb29n8)

      numerator = cmplx(real(d29, ki), aimag(d29), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dubar_emnebarbbbar_d29h3l1
