module     p0_dubar_emnebarbbbar_d4h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wmbb/1.4/Virtual/p0
   ! _dubar_emnebarbbbar/helicity3/d4h3l1d.f90
   ! generator: haggies (1.1)
   use p0_dubar_emnebarbbbar_config, only: ki
   use p0_dubar_emnebarbbbar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d4
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dubar_emnebarbbbar_globalsl1, only: epspow
      use p0_dubar_emnebarbbbar_kinematics
      use p0_dubar_emnebarbbbar_abbrevd4h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = spvak2l5(iv1)
      t2 = spvak2l6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb4n29+t2*abb4n16)
         return
      end if
      t3 = k1(iv1)
      t4 = spvak2l5(iv2)
      t5 = spvak2l6(iv2)
      t6 = k1(iv2)
      t7 = k3(iv1)
      t8 = k3(iv2)
      t9 = k4(iv1)
      t10 = k4(iv2)
      t11 = spvak2k1(iv1)
      t12 = spvak2k1(iv2)
      t13 = spvak2k4(iv1)
      t14 = spvak2k4(iv2)
      t15 = spvak3k1(iv2)
      t16 = spvak3k4(iv2)
      t17 = spvak3k1(iv1)
      t18 = spvak3k4(iv1)
      if(deg.eq.2) then
         numerator = (t1*t10*abb4n26+t1*t12*abb4n28+t1*t14*abb4n20+t1*t15*abb4n1&
         &8+t1*t16*abb4n22+t1*t6*abb4n25+t1*t8*abb4n26+t10*t2*abb4n24+t11*t4*abb&
         &4n28+t11*t5*abb4n27+t12*t2*abb4n27+t13*t4*abb4n20+t13*t5*abb4n19+t14*t&
         &2*abb4n19+t15*t2*abb4n17+t16*t2*abb4n21+t17*t4*abb4n18+t17*t5*abb4n17+&
         &t18*t4*abb4n22+t18*t5*abb4n21+t2*t6*abb4n23+t2*t8*abb4n24+t3*t4*abb4n2&
         &5+t3*t5*abb4n23+t4*t7*abb4n26+t4*t9*abb4n26+t5*t7*abb4n24+t5*t9*abb4n2&
         &4)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d4:
   subroutine     reconstruct_d4(coeffs)
      use p0_dubar_emnebarbbbar_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_4:
      coeffs%coeffs_4%c0 = derivative(czip)
      coeffs%coeffs_4%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_4%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_4%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_4%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_4%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_4%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_4%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_4%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_4%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_4%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_4%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_4%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_4%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_4%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_4:
   end subroutine reconstruct_d4
!---#] subroutine reconstruct_d4:
end module p0_dubar_emnebarbbbar_d4h3l1d
